From 529429fffc7cb65b67592e703b0f7ab28a4da53a Mon Sep 17 00:00:00 2001
From: Vitaly Slobodin <vslobodin@gitlab.com>
Date: Wed, 9 Aug 2023 17:46:47 +0000
Subject: [PATCH] Ensure git clean state after running license_finder

Our script for validating licenses does not restore
a clean git state because the whole script "scripts/license-check.sh"
is marked as "set -e" which means if any command fails with a non-zero
exit code the script terminates its execution. The failing scenario
is:
1. We start "license-check.sh" script which modifies "Gemfile.lock"
due to a workaround described inside of the script.
2. Then we run "license_finder" gem.
3. If it exits with a non-zero status code then
   the next command "git checkout -q" will never execute.

The simplest solution to resolve that failing scenario is
to capture the exit code of "license_finder" gem, store it,
restore the git clean state and exit with this exit code.
---
 scripts/license-check.sh | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/scripts/license-check.sh b/scripts/license-check.sh
index 2a210754a0d5..58dc799d0a27 100755
--- a/scripts/license-check.sh
+++ b/scripts/license-check.sh
@@ -18,6 +18,10 @@ set -euo pipefail
 
 PROJECT_PATH=${1:-`pwd`}
 
+function restore_git_state() {
+  git checkout -q Gemfile Gemfile.lock
+}
+
 echo "Using project path ${PROJECT_PATH}"
 
 GEMFILE_DIFF=`git diff Gemfile Gemfile.lock`
@@ -27,7 +31,7 @@ if [ ! -z "$GEMFILE_DIFF" ]; then
   exit 1
 fi
 
+trap restore_git_state EXIT
+
 BUNDLE_DEPLOYMENT=false BUNDLE_FROZEN=false bundle lock --add-platform `ruby -e "puts RUBY_PLATFORM"`
 bundle exec license_finder --decisions-file config/dependency_decisions.yml --project-path ${PROJECT_PATH}
-
-git checkout -q Gemfile Gemfile.lock
-- 
GitLab